--------------------------------------------------------------------------------
-- REDUCE.E - compression/decompression routines                              --
-- (c) 1998 DABERsoft - http://www27.pair.com/daber - daber@pair.com          --
--------------------------------------------------------------------------------
-- Functions:                                                                 --
-- reduce   (read_function, write_procedure)                                  --
-- unreduce (read_function, write_procedure)                                  --
--------------------------------------------------------------------------------
-- Parameters:                                                                --
-- read_function:   Routine id to be called each time a byte must be read.    --
--                  Function must return a byte.                              --
-- write_procedure: routine id to be called each time a byte must be written  --
--                  Procedure must recieve a byte as parameter                --
--------------------------------------------------------------------------------

function index(integer p1, integer p2)
    integer j
    j = xor_bits((p1*128),p2) + 1
    return j
end function

global function reduce(integer readfunc, integer writefunc)
    sequence pcTable
    integer p1,p2,c,i,ctr,bctr,mask
    sequence buf
    pcTable = repeat(32, 32768)
    buf = repeat(0,8)
    p1 = 0
    p2 = 0
    bctr = 0
    ctr = 0
    mask = 0
    c = call_func(readfunc,{})
    while c != -1 do
	if pcTable[index(p1,p2)] = c then
	    mask = xor_bits(mask,power(2,ctr))
	else
	    pcTable[index(p1,p2)] = c
	    buf[bctr+1] = c
	    bctr = bctr + 1
	end if
	ctr = ctr + 1
	if ctr = 8 then
	    call_proc(writefunc,{mask})
	    i = 0
	    while i < bctr do
		call_proc(writefunc,{buf[i+1]})
		i = i + 1
	    end while
	    ctr = 0
	    bctr = 0
	    mask = 0
	end if
	p1 = p2
	p2 = c
	c = call_func(readfunc,{})
    end while
    if ctr then
	call_proc(writefunc,{mask})
	i = 0
	while i < bctr do
	    call_proc(writefunc,{buf[i+1]})
	    i = i + 1
	end while
    end if
    return 1
end function

global function unreduce(integer readfunc, integer writefunc)
    sequence pcTable
    integer p1,p2,ctr,mask,ci,co
    integer test
    p1 = 0
    p2 = 0
    mask = 0
    pcTable = repeat(32,32768)
    ci = call_func(readfunc,{})
    while ci != -1 do
	mask = ci
	ctr = 0
	while ctr < 8 do
	    test = and_bits(mask,power(2,ctr))
	    if test then
		co = pcTable[index(p1,p2)]
	    else
		co = call_func(readfunc,{})
		if co = -1 then
		    return 1
		else
		    pcTable[index(p1,p2)] = co
		end if
	    end if
	    call_proc(writefunc,{co})
	    p1 = p2
	    p2 = co
	    ctr = ctr + 1
	end while
	ci = call_func(readfunc,{})
    end while
    return 1
end function
